/* FileChanges.c generated by valac 0.42.7, the Vala compiler
 * generated from FileChanges.vala, do not modify */

/* Copyright 2019 elementary, Inc. (https://elementary.io)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation, Inc.,; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the Free
 * Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301, USA.
 */


#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>

typedef enum  {
	MARLIN_FILE_CHANGES_KIND_INITIAL,
	MARLIN_FILE_CHANGES_KIND_ADDED,
	MARLIN_FILE_CHANGES_KIND_CHANGED,
	MARLIN_FILE_CHANGES_KIND_REMOVED,
	MARLIN_FILE_CHANGES_KIND_MOVED
} MarlinFileChangesKind;


#define MARLIN_FILE_CHANGES_TYPE_KIND (marlin_file_changes_kind_get_type ())
typedef struct _MarlinFileChangesChange MarlinFileChangesChange;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _marlin_file_changes_change_free0(var) ((var == NULL) ? NULL : (var = (marlin_file_changes_change_free (var), NULL)))
#define _g_array_unref0(var) ((var == NULL) ? NULL : (var = (g_array_unref (var), NULL)))

struct _MarlinFileChangesChange {
	MarlinFileChangesKind kind;
	GFile* from;
	GFile* to;
};


extern GQueue* marlin_file_changes_queue;
GQueue* marlin_file_changes_queue = NULL;
extern GMutex marlin_file_changes_queue_mutex;
GMutex marlin_file_changes_queue_mutex = {0};

#define MARLIN_FILE_CHANGES_CONSUME_CHANGES_MAX_CHUNK 20
GType marlin_file_changes_kind_get_type (void) G_GNUC_CONST;
void marlin_file_changes_change_free (MarlinFileChangesChange * self);
static void marlin_file_changes_change_instance_init (MarlinFileChangesChange * self);
MarlinFileChangesChange* marlin_file_changes_change_new (void);
GQueue* marlin_file_changes_get_queue (void);
static void _marlin_file_changes_change_free0_ (gpointer var);
static inline void _g_queue_free__marlin_file_changes_change_free0_ (GQueue* self);
void marlin_file_changes_queue_add_common (MarlinFileChangesChange* new_item);
void marlin_file_changes_queue_file_added (GFile* location);
void marlin_file_changes_queue_file_changed (GFile* location);
void marlin_file_changes_queue_file_removed (GFile* location);
void marlin_file_changes_queue_file_moved (GFile* from,
                                           GFile* to);
void marlin_file_changes_consume_changes (gboolean consume_all);
void gof_directory_async_notify_files_removed (GList* files);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
void gof_directory_async_notify_files_moved (GList* files);
static void _g_array_unref0_ (gpointer var);
static inline void _g_list_free__g_array_unref0_ (GList* self);
void gof_directory_async_notify_files_added (GList* files);
void gof_directory_async_notify_files_changed (GList* files);
static void _vala_GFile_free_function_content_of (gpointer data);


GType
marlin_file_changes_kind_get_type (void)
{
	static volatile gsize marlin_file_changes_kind_type_id__volatile = 0;
	if (g_once_init_enter (&marlin_file_changes_kind_type_id__volatile)) {
		static const GEnumValue values[] = {{MARLIN_FILE_CHANGES_KIND_INITIAL, "MARLIN_FILE_CHANGES_KIND_INITIAL", "initial"}, {MARLIN_FILE_CHANGES_KIND_ADDED, "MARLIN_FILE_CHANGES_KIND_ADDED", "added"}, {MARLIN_FILE_CHANGES_KIND_CHANGED, "MARLIN_FILE_CHANGES_KIND_CHANGED", "changed"}, {MARLIN_FILE_CHANGES_KIND_REMOVED, "MARLIN_FILE_CHANGES_KIND_REMOVED", "removed"}, {MARLIN_FILE_CHANGES_KIND_MOVED, "MARLIN_FILE_CHANGES_KIND_MOVED", "moved"}, {0, NULL, NULL}};
		GType marlin_file_changes_kind_type_id;
		marlin_file_changes_kind_type_id = g_enum_register_static ("MarlinFileChangesKind", values);
		g_once_init_leave (&marlin_file_changes_kind_type_id__volatile, marlin_file_changes_kind_type_id);
	}
	return marlin_file_changes_kind_type_id__volatile;
}


MarlinFileChangesChange*
marlin_file_changes_change_new (void)
{
	MarlinFileChangesChange* self;
#line 31 "../libcore/FileChanges.vala"
	self = g_slice_new0 (MarlinFileChangesChange);
#line 31 "../libcore/FileChanges.vala"
	marlin_file_changes_change_instance_init (self);
#line 31 "../libcore/FileChanges.vala"
	return self;
#line 105 "FileChanges.c"
}


static void
marlin_file_changes_change_instance_init (MarlinFileChangesChange * self)
{
}


void
marlin_file_changes_change_free (MarlinFileChangesChange * self)
{
#line 33 "../libcore/FileChanges.vala"
	_g_object_unref0 (self->from);
#line 34 "../libcore/FileChanges.vala"
	_g_object_unref0 (self->to);
#line 31 "../libcore/FileChanges.vala"
	g_slice_free (MarlinFileChangesChange, self);
#line 124 "FileChanges.c"
}


static void
_marlin_file_changes_change_free0_ (gpointer var)
{
#line 43 "../libcore/FileChanges.vala"
	(var == NULL) ? NULL : (var = (marlin_file_changes_change_free (var), NULL));
#line 133 "FileChanges.c"
}


static inline void
_g_queue_free__marlin_file_changes_change_free0_ (GQueue* self)
{
#line 43 "../libcore/FileChanges.vala"
	g_queue_free_full (self, (GDestroyNotify) _marlin_file_changes_change_free0_);
#line 142 "FileChanges.c"
}


GQueue*
marlin_file_changes_get_queue (void)
{
	GQueue* result = NULL;
	GQueue* _tmp0_;
	GQueue* _tmp2_;
#line 41 "../libcore/FileChanges.vala"
	g_mutex_lock (&marlin_file_changes_queue_mutex);
#line 42 "../libcore/FileChanges.vala"
	_tmp0_ = marlin_file_changes_queue;
#line 42 "../libcore/FileChanges.vala"
	if (_tmp0_ == NULL) {
#line 158 "FileChanges.c"
		GQueue* _tmp1_;
#line 43 "../libcore/FileChanges.vala"
		_tmp1_ = g_queue_new ();
#line 43 "../libcore/FileChanges.vala"
		(marlin_file_changes_queue == NULL) ? NULL : (marlin_file_changes_queue = (_g_queue_free__marlin_file_changes_change_free0_ (marlin_file_changes_queue), NULL));
#line 43 "../libcore/FileChanges.vala"
		marlin_file_changes_queue = _tmp1_;
#line 166 "FileChanges.c"
	}
#line 46 "../libcore/FileChanges.vala"
	g_mutex_unlock (&marlin_file_changes_queue_mutex);
#line 48 "../libcore/FileChanges.vala"
	_tmp2_ = marlin_file_changes_queue;
#line 48 "../libcore/FileChanges.vala"
	result = _tmp2_;
#line 48 "../libcore/FileChanges.vala"
	return result;
#line 176 "FileChanges.c"
}


void
marlin_file_changes_queue_add_common (MarlinFileChangesChange* new_item)
{
	GQueue* queue = NULL;
	GQueue* _tmp0_;
	MarlinFileChangesChange* _tmp1_;
#line 51 "../libcore/FileChanges.vala"
	g_return_if_fail (new_item != NULL);
#line 52 "../libcore/FileChanges.vala"
	_tmp0_ = marlin_file_changes_get_queue ();
#line 52 "../libcore/FileChanges.vala"
	queue = _tmp0_;
#line 53 "../libcore/FileChanges.vala"
	g_mutex_lock (&marlin_file_changes_queue_mutex);
#line 54 "../libcore/FileChanges.vala"
	_tmp1_ = new_item;
#line 54 "../libcore/FileChanges.vala"
	new_item = NULL;
#line 54 "../libcore/FileChanges.vala"
	g_queue_push_head (queue, _tmp1_);
#line 55 "../libcore/FileChanges.vala"
	g_mutex_unlock (&marlin_file_changes_queue_mutex);
#line 51 "../libcore/FileChanges.vala"
	_marlin_file_changes_change_free0 (new_item);
#line 204 "FileChanges.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 61 "../libcore/FileChanges.vala"
	return self ? g_object_ref (self) : NULL;
#line 213 "FileChanges.c"
}


void
marlin_file_changes_queue_file_added (GFile* location)
{
	MarlinFileChangesChange* new_item = NULL;
	MarlinFileChangesChange* _tmp0_;
	MarlinFileChangesChange* _tmp1_;
	MarlinFileChangesChange* _tmp2_;
	GFile* _tmp3_;
	MarlinFileChangesChange* _tmp4_;
#line 58 "../libcore/FileChanges.vala"
	g_return_if_fail (location != NULL);
#line 59 "../libcore/FileChanges.vala"
	_tmp0_ = marlin_file_changes_change_new ();
#line 59 "../libcore/FileChanges.vala"
	new_item = _tmp0_;
#line 60 "../libcore/FileChanges.vala"
	_tmp1_ = new_item;
#line 60 "../libcore/FileChanges.vala"
	_tmp1_->kind = MARLIN_FILE_CHANGES_KIND_ADDED;
#line 61 "../libcore/FileChanges.vala"
	_tmp2_ = new_item;
#line 61 "../libcore/FileChanges.vala"
	_tmp3_ = _g_object_ref0 (location);
#line 61 "../libcore/FileChanges.vala"
	_g_object_unref0 (_tmp2_->from);
#line 61 "../libcore/FileChanges.vala"
	_tmp2_->from = _tmp3_;
#line 62 "../libcore/FileChanges.vala"
	_tmp4_ = new_item;
#line 62 "../libcore/FileChanges.vala"
	new_item = NULL;
#line 62 "../libcore/FileChanges.vala"
	marlin_file_changes_queue_add_common (_tmp4_);
#line 58 "../libcore/FileChanges.vala"
	_marlin_file_changes_change_free0 (new_item);
#line 252 "FileChanges.c"
}


void
marlin_file_changes_queue_file_changed (GFile* location)
{
	MarlinFileChangesChange* new_item = NULL;
	MarlinFileChangesChange* _tmp0_;
	MarlinFileChangesChange* _tmp1_;
	MarlinFileChangesChange* _tmp2_;
	GFile* _tmp3_;
	MarlinFileChangesChange* _tmp4_;
#line 65 "../libcore/FileChanges.vala"
	g_return_if_fail (location != NULL);
#line 66 "../libcore/FileChanges.vala"
	_tmp0_ = marlin_file_changes_change_new ();
#line 66 "../libcore/FileChanges.vala"
	new_item = _tmp0_;
#line 67 "../libcore/FileChanges.vala"
	_tmp1_ = new_item;
#line 67 "../libcore/FileChanges.vala"
	_tmp1_->kind = MARLIN_FILE_CHANGES_KIND_CHANGED;
#line 68 "../libcore/FileChanges.vala"
	_tmp2_ = new_item;
#line 68 "../libcore/FileChanges.vala"
	_tmp3_ = _g_object_ref0 (location);
#line 68 "../libcore/FileChanges.vala"
	_g_object_unref0 (_tmp2_->from);
#line 68 "../libcore/FileChanges.vala"
	_tmp2_->from = _tmp3_;
#line 69 "../libcore/FileChanges.vala"
	_tmp4_ = new_item;
#line 69 "../libcore/FileChanges.vala"
	new_item = NULL;
#line 69 "../libcore/FileChanges.vala"
	marlin_file_changes_queue_add_common (_tmp4_);
#line 65 "../libcore/FileChanges.vala"
	_marlin_file_changes_change_free0 (new_item);
#line 291 "FileChanges.c"
}


void
marlin_file_changes_queue_file_removed (GFile* location)
{
	MarlinFileChangesChange* new_item = NULL;
	MarlinFileChangesChange* _tmp0_;
	MarlinFileChangesChange* _tmp1_;
	MarlinFileChangesChange* _tmp2_;
	GFile* _tmp3_;
	MarlinFileChangesChange* _tmp4_;
#line 72 "../libcore/FileChanges.vala"
	g_return_if_fail (location != NULL);
#line 73 "../libcore/FileChanges.vala"
	_tmp0_ = marlin_file_changes_change_new ();
#line 73 "../libcore/FileChanges.vala"
	new_item = _tmp0_;
#line 74 "../libcore/FileChanges.vala"
	_tmp1_ = new_item;
#line 74 "../libcore/FileChanges.vala"
	_tmp1_->kind = MARLIN_FILE_CHANGES_KIND_REMOVED;
#line 75 "../libcore/FileChanges.vala"
	_tmp2_ = new_item;
#line 75 "../libcore/FileChanges.vala"
	_tmp3_ = _g_object_ref0 (location);
#line 75 "../libcore/FileChanges.vala"
	_g_object_unref0 (_tmp2_->from);
#line 75 "../libcore/FileChanges.vala"
	_tmp2_->from = _tmp3_;
#line 76 "../libcore/FileChanges.vala"
	_tmp4_ = new_item;
#line 76 "../libcore/FileChanges.vala"
	new_item = NULL;
#line 76 "../libcore/FileChanges.vala"
	marlin_file_changes_queue_add_common (_tmp4_);
#line 72 "../libcore/FileChanges.vala"
	_marlin_file_changes_change_free0 (new_item);
#line 330 "FileChanges.c"
}


void
marlin_file_changes_queue_file_moved (GFile* from,
                                      GFile* to)
{
	MarlinFileChangesChange* new_item = NULL;
	MarlinFileChangesChange* _tmp0_;
	MarlinFileChangesChange* _tmp1_;
	MarlinFileChangesChange* _tmp2_;
	GFile* _tmp3_;
	MarlinFileChangesChange* _tmp4_;
	GFile* _tmp5_;
	MarlinFileChangesChange* _tmp6_;
#line 79 "../libcore/FileChanges.vala"
	g_return_if_fail (from != NULL);
#line 79 "../libcore/FileChanges.vala"
	g_return_if_fail (to != NULL);
#line 80 "../libcore/FileChanges.vala"
	_tmp0_ = marlin_file_changes_change_new ();
#line 80 "../libcore/FileChanges.vala"
	new_item = _tmp0_;
#line 81 "../libcore/FileChanges.vala"
	_tmp1_ = new_item;
#line 81 "../libcore/FileChanges.vala"
	_tmp1_->kind = MARLIN_FILE_CHANGES_KIND_MOVED;
#line 82 "../libcore/FileChanges.vala"
	_tmp2_ = new_item;
#line 82 "../libcore/FileChanges.vala"
	_tmp3_ = _g_object_ref0 (from);
#line 82 "../libcore/FileChanges.vala"
	_g_object_unref0 (_tmp2_->from);
#line 82 "../libcore/FileChanges.vala"
	_tmp2_->from = _tmp3_;
#line 83 "../libcore/FileChanges.vala"
	_tmp4_ = new_item;
#line 83 "../libcore/FileChanges.vala"
	_tmp5_ = _g_object_ref0 (to);
#line 83 "../libcore/FileChanges.vala"
	_g_object_unref0 (_tmp4_->to);
#line 83 "../libcore/FileChanges.vala"
	_tmp4_->to = _tmp5_;
#line 84 "../libcore/FileChanges.vala"
	_tmp6_ = new_item;
#line 84 "../libcore/FileChanges.vala"
	new_item = NULL;
#line 84 "../libcore/FileChanges.vala"
	marlin_file_changes_queue_add_common (_tmp6_);
#line 79 "../libcore/FileChanges.vala"
	_marlin_file_changes_change_free0 (new_item);
#line 382 "FileChanges.c"
}


static void
_g_object_unref0_ (gpointer var)
{
#line 137 "../libcore/FileChanges.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 391 "FileChanges.c"
}


static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 137 "../libcore/FileChanges.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 400 "FileChanges.c"
}


static void
_g_array_unref0_ (gpointer var)
{
#line 143 "../libcore/FileChanges.vala"
	(var == NULL) ? NULL : (var = (g_array_unref (var), NULL));
#line 409 "FileChanges.c"
}


static inline void
_g_list_free__g_array_unref0_ (GList* self)
{
#line 143 "../libcore/FileChanges.vala"
	g_list_free_full (self, (GDestroyNotify) _g_array_unref0_);
#line 418 "FileChanges.c"
}


static void
_vala_GFile_free_function_content_of (gpointer data)
{
	GFile* self;
#line 195 "../libcore/FileChanges.vala"
	self = *((GFile**) data);
#line 195 "../libcore/FileChanges.vala"
	_g_object_unref0_ (self);
#line 430 "FileChanges.c"
}


static gpointer
_g_array_ref0 (gpointer self)
{
#line 198 "../libcore/FileChanges.vala"
	return self ? g_array_ref (self) : NULL;
#line 439 "FileChanges.c"
}


void
marlin_file_changes_consume_changes (gboolean consume_all)
{
	GQueue* queue = NULL;
	GQueue* _tmp0_;
	guint chunk_count = 0U;
	gboolean flush_needed = FALSE;
	GList* additions = NULL;
	GList* changes = NULL;
	GList* deletions = NULL;
	GList* moves = NULL;
#line 88 "../libcore/FileChanges.vala"
	_tmp0_ = marlin_file_changes_get_queue ();
#line 88 "../libcore/FileChanges.vala"
	queue = _tmp0_;
#line 91 "../libcore/FileChanges.vala"
	additions = NULL;
#line 92 "../libcore/FileChanges.vala"
	changes = NULL;
#line 93 "../libcore/FileChanges.vala"
	deletions = NULL;
#line 94 "../libcore/FileChanges.vala"
	moves = NULL;
#line 466 "FileChanges.c"
	{
		gboolean _tmp1_ = FALSE;
#line 101 "../libcore/FileChanges.vala"
		chunk_count = (guint) 0;
#line 101 "../libcore/FileChanges.vala"
		_tmp1_ = TRUE;
#line 101 "../libcore/FileChanges.vala"
		while (TRUE) {
#line 475 "FileChanges.c"
			MarlinFileChangesChange* change = NULL;
			GQueue* _tmp3_;
			gpointer _tmp4_;
			MarlinFileChangesChange* _tmp5_;
			gboolean _tmp28_;
			MarlinFileChangesChange* _tmp37_;
			MarlinFileChangesChange* _tmp38_;
			MarlinFileChangesKind _tmp39_;
#line 101 "../libcore/FileChanges.vala"
			if (!_tmp1_) {
#line 486 "FileChanges.c"
				guint _tmp2_;
#line 101 "../libcore/FileChanges.vala"
				_tmp2_ = chunk_count;
#line 101 "../libcore/FileChanges.vala"
				chunk_count = _tmp2_ + 1;
#line 492 "FileChanges.c"
			}
#line 101 "../libcore/FileChanges.vala"
			_tmp1_ = FALSE;
#line 102 "../libcore/FileChanges.vala"
			g_mutex_lock (&marlin_file_changes_queue_mutex);
#line 103 "../libcore/FileChanges.vala"
			_tmp3_ = queue;
#line 103 "../libcore/FileChanges.vala"
			_tmp4_ = g_queue_pop_tail (_tmp3_);
#line 103 "../libcore/FileChanges.vala"
			change = (MarlinFileChangesChange*) _tmp4_;
#line 104 "../libcore/FileChanges.vala"
			g_mutex_unlock (&marlin_file_changes_queue_mutex);
#line 108 "../libcore/FileChanges.vala"
			_tmp5_ = change;
#line 108 "../libcore/FileChanges.vala"
			if (_tmp5_ == NULL) {
#line 109 "../libcore/FileChanges.vala"
				flush_needed = TRUE;
#line 512 "FileChanges.c"
			} else {
				gboolean _tmp6_ = FALSE;
				GList* _tmp7_;
				gboolean _tmp10_ = FALSE;
				GList* _tmp11_;
				gboolean _tmp14_;
				gboolean _tmp15_ = FALSE;
				GList* _tmp16_;
				gboolean _tmp19_;
				gboolean _tmp20_ = FALSE;
				GList* _tmp21_;
				gboolean _tmp24_;
				gboolean _tmp25_ = FALSE;
				gboolean _tmp27_;
#line 112 "../libcore/FileChanges.vala"
				_tmp7_ = additions;
#line 112 "../libcore/FileChanges.vala"
				if (_tmp7_ != NULL) {
#line 531 "FileChanges.c"
					MarlinFileChangesChange* _tmp8_;
					MarlinFileChangesKind _tmp9_;
#line 113 "../libcore/FileChanges.vala"
					_tmp8_ = change;
#line 113 "../libcore/FileChanges.vala"
					_tmp9_ = _tmp8_->kind;
#line 113 "../libcore/FileChanges.vala"
					_tmp6_ = _tmp9_ != MARLIN_FILE_CHANGES_KIND_ADDED;
#line 540 "FileChanges.c"
				} else {
#line 112 "../libcore/FileChanges.vala"
					_tmp6_ = FALSE;
#line 544 "FileChanges.c"
				}
#line 112 "../libcore/FileChanges.vala"
				flush_needed = _tmp6_;
#line 115 "../libcore/FileChanges.vala"
				_tmp11_ = changes;
#line 115 "../libcore/FileChanges.vala"
				if (_tmp11_ != NULL) {
#line 552 "FileChanges.c"
					MarlinFileChangesChange* _tmp12_;
					MarlinFileChangesKind _tmp13_;
#line 116 "../libcore/FileChanges.vala"
					_tmp12_ = change;
#line 116 "../libcore/FileChanges.vala"
					_tmp13_ = _tmp12_->kind;
#line 116 "../libcore/FileChanges.vala"
					_tmp10_ = _tmp13_ != MARLIN_FILE_CHANGES_KIND_CHANGED;
#line 561 "FileChanges.c"
				} else {
#line 115 "../libcore/FileChanges.vala"
					_tmp10_ = FALSE;
#line 565 "FileChanges.c"
				}
#line 115 "../libcore/FileChanges.vala"
				_tmp14_ = flush_needed;
#line 115 "../libcore/FileChanges.vala"
				flush_needed = _tmp14_ | _tmp10_;
#line 118 "../libcore/FileChanges.vala"
				_tmp16_ = moves;
#line 118 "../libcore/FileChanges.vala"
				if (_tmp16_ != NULL) {
#line 575 "FileChanges.c"
					MarlinFileChangesChange* _tmp17_;
					MarlinFileChangesKind _tmp18_;
#line 119 "../libcore/FileChanges.vala"
					_tmp17_ = change;
#line 119 "../libcore/FileChanges.vala"
					_tmp18_ = _tmp17_->kind;
#line 119 "../libcore/FileChanges.vala"
					_tmp15_ = _tmp18_ != MARLIN_FILE_CHANGES_KIND_MOVED;
#line 584 "FileChanges.c"
				} else {
#line 118 "../libcore/FileChanges.vala"
					_tmp15_ = FALSE;
#line 588 "FileChanges.c"
				}
#line 118 "../libcore/FileChanges.vala"
				_tmp19_ = flush_needed;
#line 118 "../libcore/FileChanges.vala"
				flush_needed = _tmp19_ | _tmp15_;
#line 121 "../libcore/FileChanges.vala"
				_tmp21_ = deletions;
#line 121 "../libcore/FileChanges.vala"
				if (_tmp21_ != NULL) {
#line 598 "FileChanges.c"
					MarlinFileChangesChange* _tmp22_;
					MarlinFileChangesKind _tmp23_;
#line 122 "../libcore/FileChanges.vala"
					_tmp22_ = change;
#line 122 "../libcore/FileChanges.vala"
					_tmp23_ = _tmp22_->kind;
#line 122 "../libcore/FileChanges.vala"
					_tmp20_ = _tmp23_ != MARLIN_FILE_CHANGES_KIND_REMOVED;
#line 607 "FileChanges.c"
				} else {
#line 121 "../libcore/FileChanges.vala"
					_tmp20_ = FALSE;
#line 611 "FileChanges.c"
				}
#line 121 "../libcore/FileChanges.vala"
				_tmp24_ = flush_needed;
#line 121 "../libcore/FileChanges.vala"
				flush_needed = _tmp24_ | _tmp20_;
#line 124 "../libcore/FileChanges.vala"
				if (!consume_all) {
#line 619 "FileChanges.c"
					guint _tmp26_;
#line 124 "../libcore/FileChanges.vala"
					_tmp26_ = chunk_count;
#line 124 "../libcore/FileChanges.vala"
					_tmp25_ = _tmp26_ >= ((guint) MARLIN_FILE_CHANGES_CONSUME_CHANGES_MAX_CHUNK);
#line 625 "FileChanges.c"
				} else {
#line 124 "../libcore/FileChanges.vala"
					_tmp25_ = FALSE;
#line 629 "FileChanges.c"
				}
#line 124 "../libcore/FileChanges.vala"
				_tmp27_ = flush_needed;
#line 124 "../libcore/FileChanges.vala"
				flush_needed = _tmp27_ | _tmp25_;
#line 635 "FileChanges.c"
			}
#line 128 "../libcore/FileChanges.vala"
			_tmp28_ = flush_needed;
#line 128 "../libcore/FileChanges.vala"
			if (_tmp28_) {
#line 641 "FileChanges.c"
				GList* _tmp29_;
				GList* _tmp31_;
				GList* _tmp33_;
				GList* _tmp35_;
#line 134 "../libcore/FileChanges.vala"
				_tmp29_ = deletions;
#line 134 "../libcore/FileChanges.vala"
				if (_tmp29_ != NULL) {
#line 650 "FileChanges.c"
					GList* _tmp30_;
#line 135 "../libcore/FileChanges.vala"
					deletions = g_list_reverse (deletions);
#line 136 "../libcore/FileChanges.vala"
					_tmp30_ = deletions;
#line 136 "../libcore/FileChanges.vala"
					gof_directory_async_notify_files_removed (_tmp30_);
#line 137 "../libcore/FileChanges.vala"
					(deletions == NULL) ? NULL : (deletions = (_g_list_free__g_object_unref0_ (deletions), NULL));
#line 137 "../libcore/FileChanges.vala"
					deletions = NULL;
#line 662 "FileChanges.c"
				}
#line 140 "../libcore/FileChanges.vala"
				_tmp31_ = moves;
#line 140 "../libcore/FileChanges.vala"
				if (_tmp31_ != NULL) {
#line 668 "FileChanges.c"
					GList* _tmp32_;
#line 141 "../libcore/FileChanges.vala"
					moves = g_list_reverse (moves);
#line 142 "../libcore/FileChanges.vala"
					_tmp32_ = moves;
#line 142 "../libcore/FileChanges.vala"
					gof_directory_async_notify_files_moved (_tmp32_);
#line 143 "../libcore/FileChanges.vala"
					(moves == NULL) ? NULL : (moves = (_g_list_free__g_array_unref0_ (moves), NULL));
#line 143 "../libcore/FileChanges.vala"
					moves = NULL;
#line 680 "FileChanges.c"
				}
#line 146 "../libcore/FileChanges.vala"
				_tmp33_ = additions;
#line 146 "../libcore/FileChanges.vala"
				if (_tmp33_ != NULL) {
#line 686 "FileChanges.c"
					GList* _tmp34_;
#line 147 "../libcore/FileChanges.vala"
					additions = g_list_reverse (additions);
#line 148 "../libcore/FileChanges.vala"
					_tmp34_ = additions;
#line 148 "../libcore/FileChanges.vala"
					gof_directory_async_notify_files_added (_tmp34_);
#line 149 "../libcore/FileChanges.vala"
					(additions == NULL) ? NULL : (additions = (_g_list_free__g_object_unref0_ (additions), NULL));
#line 149 "../libcore/FileChanges.vala"
					additions = NULL;
#line 698 "FileChanges.c"
				}
#line 152 "../libcore/FileChanges.vala"
				_tmp35_ = changes;
#line 152 "../libcore/FileChanges.vala"
				if (_tmp35_ != NULL) {
#line 704 "FileChanges.c"
					GList* _tmp36_;
#line 153 "../libcore/FileChanges.vala"
					changes = g_list_reverse (changes);
#line 154 "../libcore/FileChanges.vala"
					_tmp36_ = changes;
#line 154 "../libcore/FileChanges.vala"
					gof_directory_async_notify_files_changed (_tmp36_);
#line 155 "../libcore/FileChanges.vala"
					(changes == NULL) ? NULL : (changes = (_g_list_free__g_object_unref0_ (changes), NULL));
#line 155 "../libcore/FileChanges.vala"
					changes = NULL;
#line 716 "FileChanges.c"
				}
			}
#line 159 "../libcore/FileChanges.vala"
			_tmp37_ = change;
#line 159 "../libcore/FileChanges.vala"
			if (_tmp37_ == NULL) {
#line 161 "../libcore/FileChanges.vala"
				_marlin_file_changes_change_free0 (change);
#line 161 "../libcore/FileChanges.vala"
				(moves == NULL) ? NULL : (moves = (_g_list_free__g_array_unref0_ (moves), NULL));
#line 161 "../libcore/FileChanges.vala"
				(deletions == NULL) ? NULL : (deletions = (_g_list_free__g_object_unref0_ (deletions), NULL));
#line 161 "../libcore/FileChanges.vala"
				(changes == NULL) ? NULL : (changes = (_g_list_free__g_object_unref0_ (changes), NULL));
#line 161 "../libcore/FileChanges.vala"
				(additions == NULL) ? NULL : (additions = (_g_list_free__g_object_unref0_ (additions), NULL));
#line 161 "../libcore/FileChanges.vala"
				return;
#line 735 "FileChanges.c"
			}
#line 165 "../libcore/FileChanges.vala"
			_tmp38_ = change;
#line 165 "../libcore/FileChanges.vala"
			_tmp39_ = _tmp38_->kind;
#line 165 "../libcore/FileChanges.vala"
			switch (_tmp39_) {
#line 165 "../libcore/FileChanges.vala"
				case MARLIN_FILE_CHANGES_KIND_ADDED:
#line 745 "FileChanges.c"
				{
					GList* _tmp40_;
					MarlinFileChangesChange* _tmp41_;
					GFile* _tmp42_;
					GFile* _tmp43_;
#line 167 "../libcore/FileChanges.vala"
					_tmp40_ = additions;
#line 167 "../libcore/FileChanges.vala"
					if (_tmp40_ == NULL) {
#line 168 "../libcore/FileChanges.vala"
						(additions == NULL) ? NULL : (additions = (_g_list_free__g_object_unref0_ (additions), NULL));
#line 168 "../libcore/FileChanges.vala"
						additions = NULL;
#line 759 "FileChanges.c"
					}
#line 171 "../libcore/FileChanges.vala"
					_tmp41_ = change;
#line 171 "../libcore/FileChanges.vala"
					_tmp42_ = _tmp41_->from;
#line 171 "../libcore/FileChanges.vala"
					_tmp43_ = _g_object_ref0 (_tmp42_);
#line 171 "../libcore/FileChanges.vala"
					additions = g_list_prepend (additions, _tmp43_);
#line 172 "../libcore/FileChanges.vala"
					break;
#line 771 "FileChanges.c"
				}
#line 165 "../libcore/FileChanges.vala"
				case MARLIN_FILE_CHANGES_KIND_CHANGED:
#line 775 "FileChanges.c"
				{
					GList* _tmp44_;
					MarlinFileChangesChange* _tmp45_;
					GFile* _tmp46_;
					GFile* _tmp47_;
#line 175 "../libcore/FileChanges.vala"
					_tmp44_ = changes;
#line 175 "../libcore/FileChanges.vala"
					if (_tmp44_ == NULL) {
#line 176 "../libcore/FileChanges.vala"
						(changes == NULL) ? NULL : (changes = (_g_list_free__g_object_unref0_ (changes), NULL));
#line 176 "../libcore/FileChanges.vala"
						changes = NULL;
#line 789 "FileChanges.c"
					}
#line 179 "../libcore/FileChanges.vala"
					_tmp45_ = change;
#line 179 "../libcore/FileChanges.vala"
					_tmp46_ = _tmp45_->from;
#line 179 "../libcore/FileChanges.vala"
					_tmp47_ = _g_object_ref0 (_tmp46_);
#line 179 "../libcore/FileChanges.vala"
					changes = g_list_prepend (changes, _tmp47_);
#line 180 "../libcore/FileChanges.vala"
					break;
#line 801 "FileChanges.c"
				}
#line 165 "../libcore/FileChanges.vala"
				case MARLIN_FILE_CHANGES_KIND_REMOVED:
#line 805 "FileChanges.c"
				{
					GList* _tmp48_;
					MarlinFileChangesChange* _tmp49_;
					GFile* _tmp50_;
					GFile* _tmp51_;
#line 183 "../libcore/FileChanges.vala"
					_tmp48_ = deletions;
#line 183 "../libcore/FileChanges.vala"
					if (_tmp48_ == NULL) {
#line 184 "../libcore/FileChanges.vala"
						(deletions == NULL) ? NULL : (deletions = (_g_list_free__g_object_unref0_ (deletions), NULL));
#line 184 "../libcore/FileChanges.vala"
						deletions = NULL;
#line 819 "FileChanges.c"
					}
#line 187 "../libcore/FileChanges.vala"
					_tmp49_ = change;
#line 187 "../libcore/FileChanges.vala"
					_tmp50_ = _tmp49_->from;
#line 187 "../libcore/FileChanges.vala"
					_tmp51_ = _g_object_ref0 (_tmp50_);
#line 187 "../libcore/FileChanges.vala"
					deletions = g_list_prepend (deletions, _tmp51_);
#line 188 "../libcore/FileChanges.vala"
					break;
#line 831 "FileChanges.c"
				}
#line 165 "../libcore/FileChanges.vala"
				case MARLIN_FILE_CHANGES_KIND_MOVED:
#line 835 "FileChanges.c"
				{
					GList* _tmp52_;
					GArray* pair = NULL;
					GArray* _tmp53_;
					GArray* _tmp54_;
					MarlinFileChangesChange* _tmp55_;
					GFile* _tmp56_;
					GFile* _tmp57_;
					GArray* _tmp58_;
					MarlinFileChangesChange* _tmp59_;
					GFile* _tmp60_;
					GFile* _tmp61_;
					GArray* _tmp62_;
					GArray* _tmp63_;
#line 191 "../libcore/FileChanges.vala"
					_tmp52_ = moves;
#line 191 "../libcore/FileChanges.vala"
					if (_tmp52_ == NULL) {
#line 192 "../libcore/FileChanges.vala"
						(moves == NULL) ? NULL : (moves = (_g_list_free__g_array_unref0_ (moves), NULL));
#line 192 "../libcore/FileChanges.vala"
						moves = NULL;
#line 858 "FileChanges.c"
					}
#line 195 "../libcore/FileChanges.vala"
					_tmp53_ = g_array_sized_new (FALSE, FALSE, sizeof (GFile*), (guint) 2);
#line 195 "../libcore/FileChanges.vala"
					g_array_set_clear_func (_tmp53_, _vala_GFile_free_function_content_of);
#line 195 "../libcore/FileChanges.vala"
					pair = _tmp53_;
#line 196 "../libcore/FileChanges.vala"
					_tmp54_ = pair;
#line 196 "../libcore/FileChanges.vala"
					_tmp55_ = change;
#line 196 "../libcore/FileChanges.vala"
					_tmp56_ = _tmp55_->from;
#line 196 "../libcore/FileChanges.vala"
					_tmp57_ = _g_object_ref0 (_tmp56_);
#line 196 "../libcore/FileChanges.vala"
					g_array_append_val (_tmp54_, _tmp57_);
#line 197 "../libcore/FileChanges.vala"
					_tmp58_ = pair;
#line 197 "../libcore/FileChanges.vala"
					_tmp59_ = change;
#line 197 "../libcore/FileChanges.vala"
					_tmp60_ = _tmp59_->to;
#line 197 "../libcore/FileChanges.vala"
					_tmp61_ = _g_object_ref0 (_tmp60_);
#line 197 "../libcore/FileChanges.vala"
					g_array_append_val (_tmp58_, _tmp61_);
#line 198 "../libcore/FileChanges.vala"
					_tmp62_ = pair;
#line 198 "../libcore/FileChanges.vala"
					_tmp63_ = _g_array_ref0 (_tmp62_);
#line 198 "../libcore/FileChanges.vala"
					moves = g_list_prepend (moves, _tmp63_);
#line 199 "../libcore/FileChanges.vala"
					_g_array_unref0 (pair);
#line 199 "../libcore/FileChanges.vala"
					break;
#line 896 "FileChanges.c"
				}
				default:
				{
#line 202 "../libcore/FileChanges.vala"
					g_assert_not_reached ();
#line 902 "FileChanges.c"
				}
			}
#line 101 "../libcore/FileChanges.vala"
			_marlin_file_changes_change_free0 (change);
#line 907 "FileChanges.c"
		}
	}
#line 87 "../libcore/FileChanges.vala"
	(moves == NULL) ? NULL : (moves = (_g_list_free__g_array_unref0_ (moves), NULL));
#line 87 "../libcore/FileChanges.vala"
	(deletions == NULL) ? NULL : (deletions = (_g_list_free__g_object_unref0_ (deletions), NULL));
#line 87 "../libcore/FileChanges.vala"
	(changes == NULL) ? NULL : (changes = (_g_list_free__g_object_unref0_ (changes), NULL));
#line 87 "../libcore/FileChanges.vala"
	(additions == NULL) ? NULL : (additions = (_g_list_free__g_object_unref0_ (additions), NULL));
#line 918 "FileChanges.c"
}



